require_relative "../lib/postcode_three_country/version"
require "yaml"
require "pry"


module PostcodeThreeCountry
	def self.hello
		puts "Hello from Postcode"
	end

	def self.vi_country
		@vi_postcode = YAML::load_file(File.join(__dir__, "data/vietnam_zipcode.yaml"))
	end

	def self.jp_country
		@jp_postcode = YAML::load_file(File.join(__dir__, "data/japan_zipcode.yaml"))
	end

	def self.eng_country
		@eng_postcode = YAML::load_file(File.join(__dir__, "data/england_zipcode.yaml"))
	end

	# Xử lý khi tìm tên thành phố bằng Postcode của Việt Nam
	def self.vi_postcode_find_city find_city
		vi_country

		array_country = @vi_postcode['vietnam'].values
		find_city = find_city.gsub(/\D/, '')
		first_word = find_city.split('')[0]
		array_postcode = []
		array_city = []

		array_country.each do |country|
			array_postcode << country.values[0]
			array_city << country.values[1]
		end
		if array_postcode.include?(find_city)
			array_country.each do |city|
				puts city.values[1] if city.has_value?(find_city)
			end
		else
			puts array_postcode.map { |v| puts v if v.start_with?(first_word) }
		end
	end

	# Xử lý khi tìm tên thành phố bằng Postcode của Japan
	def self.jp_postcode_find_city find_city
		jp_country

		array_country = @jp_postcode['japan'].values
		find_city = find_city.gsub(/\D/, '')
		first_word = find_city.split('')[0]
		array_postcode = []
		array_city = []

		array_country.each do |country|
			array_postcode << country.values[0]
			array_city << country.values[1]
		end
		if array_postcode.include?(find_city)
			array_country.each do |city|
				puts city.values[1] if city.has_value?(find_city)
			end
		else
			puts array_postcode.map { |v| puts v if v.start_with?(first_word) }
		end
	end

	# Xử lý khi tìm tên thành phố bằng Postcode của England
	def self.eng_postcode_find_city find_city
		eng_country

		array_country = @eng_postcode['england'].values
		find_city = find_city.gsub(/\D/, '')
		first_word = find_city.split('')[0]
		array_postcode = []
		array_city = []

		array_country.each do |country|
			array_postcode << country.values[0]
			array_city << country.values[1]
		end
		if array_postcode.include?(find_city)
			array_country.each do |city|
				puts city.values[1] if city.has_value?(find_city)
			end
		else
			puts array_postcode.map { |v| puts v if v.start_with?(first_word) }
		end
	end

	# Xử lý khi tìm Postcode bằng tên thành phố của Vietnam
	def self.vi_city_find_postcode find_postcode
		vi_country

		array_country = @vi_postcode['vietnam'].values
		find_postcode = find_postcode.gsub(/[\W\d]/, '')
		first_word = find_postcode.split('')[0]
		array_postcode = []
		array_city = []

		array_country.each do |country|
			array_postcode << country.values[0]
			array_city << country.values[1]
		end
		if array_city.include?(find_postcode)
			array_country.each do |postcode|
				puts postcode.values[0] if postcode.has_value?(find_postcode)
			end
		else
			# binding.pry
			puts array_city.map { |v| puts v if v.start_with?(first_word) }
		end
	end

	# Xử lý khi tìm Postcode bằng tên thành phố của Japan
	def self.jp_city_find_postcode find_postcode
		jp_country

		array_country = @jp_postcode['japan'].values
		find_postcode = find_postcode.gsub(/[\W\d]/, '')
		first_word = find_postcode.split('')[0]
		array_postcode = []
		array_city = []

		array_country.each do |country|
			array_postcode << country.values[0]
			array_city << country.values[1]
		end
		if array_city.include?(find_postcode)
			array_country.each do |postcode|
				puts postcode.values[0] if postcode.has_value?(find_postcode)
			end
		else
			puts array_city.map { |v| puts v if v.start_with?(first_word) }
		end
		# binding.pry
	end

	# Xử lý khi tìm Postcode bằng tên thành phố của Vietnam
	def self.eng_city_find_postcode find_postcode
		eng_country

		array_country = @eng_postcode['england'].values
		find_postcode = find_postcode.gsub(/[\W\d]/, '')
		first_word = find_postcode.split('')[0]
		array_postcode = []
		array_city = []

		array_country.each do |country|
			array_postcode << country.values[0]
			array_city << country.values[1]
		end
		if array_city.include?(find_postcode)
			array_country.each do |postcode|
				puts postcode.values[0] if postcode.has_value?(find_postcode)
			end
		else
			puts array_city.map { |v| puts v if v.start_with?(first_word) }
		end
		# binding.pry
	end
end